﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MyFontResolver;
using PdfSharp.Drawing;
using PdfSharp.Fonts;
using PdfSharp.Pdf;

namespace FontResolverDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            // That's all it takes to register your own fontresolver
            GlobalFontSettings.FontResolver = new DemoFontResolver();

            // And here is the slightly modified PDFsharp Hello World sample.

            // Create a new PDF document
            PdfDocument document = new PdfDocument();
            document.Info.Title = "Created with PDFsharp";

            // Create an empty page
            PdfPage page = document.AddPage();

            // Get an XGraphics object for drawing
            XGraphics gfx = XGraphics.FromPdfPage(page);

            // Create a font
            XFont font = new XFont("Ubuntu", 20, XFontStyle.BoldItalic);

            // Draw the text
            gfx.DrawString("Hello, World!", font, XBrushes.Black,
              new XRect(0, 0, page.Width, 50),
              XStringFormats.Center);

            font = new XFont("Ubuntu", 20, XFontStyle.Italic);
            gfx.DrawString("Hello, World!", font, XBrushes.Black,
              new XRect(0, 50, page.Width, 50),
              XStringFormats.Center);

            font = new XFont("Ubuntu", 20, XFontStyle.Bold);
            gfx.DrawString("Hello, World!", font, XBrushes.Black,
              new XRect(0, 100, page.Width, 50),
              XStringFormats.Center);

            font = new XFont("Ubuntu", 20, XFontStyle.Regular);
            gfx.DrawString("Hello, World!", font, XBrushes.Black,
              new XRect(0, 150, page.Width, 50),
              XStringFormats.Center);

            font = new XFont("Janitor", 20, XFontStyle.Regular);
            gfx.DrawString("Hello, World!", font, XBrushes.Black,
              new XRect(0, 200, page.Width, 50),
              XStringFormats.Center);

            font = new XFont("Arial", 20, XFontStyle.Regular);
            gfx.DrawString("Hello, World!", font, XBrushes.Black,
              new XRect(0, 250, page.Width, 50),
              XStringFormats.Center);

            font = new XFont("Courier New", 20, XFontStyle.Regular);
            gfx.DrawString("Hello, World!", font, XBrushes.Black,
              new XRect(0, 300, page.Width, 50),
              XStringFormats.Center);

            font = new XFont("Comic Sans MS", 20, XFontStyle.Regular);
            gfx.DrawString("Hello, World!", font, XBrushes.Black,
              new XRect(0, 350, page.Width, 50),
              XStringFormats.Center);

            // This will lead to an exception.
            //font = new XFont("Xyz Unknown Font", 20, XFontStyle.Regular);
            //gfx.DrawString("Hello, World!", font, XBrushes.Black,
            //  new XRect(0, 400, page.Width, 50),
            //  XStringFormats.Center);

            // Save the document...
            const string filename = "HelloWorld.pdf";
            document.Save(filename);
            // ...and start a viewer.
            Process.Start(filename);

        }
    }
}
